//mmap-reserve-space.c:

#define _GNU_SOURCE

#include <sys/mman.h>
#include <unistd.h>
#include <stdio.h>
//#include <sys/prctl.h>

#define LEN (1LLU<<60)

int main (void) {
    void *area;
    size_t len = LEN;

    do {
        len >>= 1;
        area = mmap(NULL, len, PROT_NONE, MAP_SHARED|MAP_ANONYMOUS|MAP_NORESERVE, -1, 0);
    } while (area == MAP_FAILED && len > 1024);
    //prctl(PR_SET_VMA, PR_SET_VMA_ANON_NAME, area, LEN, "reserved");

    printf("area=%p, len=%zu\n", area, len);

    sleep(10);

    if (area != MAP_FAILED)
        munmap(area, len);

    return 0;
}

//ll
